unit Singlei;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Spin, StdCtrls, Buttons;

type
  TMainForm = class(TForm)
    Timer1: TTimer;
    PaintBox1: TPaintBox;
    Bevel1: TBevel;
    ADChanEd: TEdit;
    RateEd: TEdit;
    CancelBtn: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    ADChanSB: TSpinButton;
    PeriodSB: TSpinButton;
    ModeCB: TCheckBox;
    ErrorLab: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure ADChanSBDownClick(Sender: TObject);
    procedure PeriodSBDownClick(Sender: TObject);
    procedure PeriodSBUpClick(Sender: TObject);
    procedure ADChanSBUpClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure PutVariables;
    procedure GetVariables;
    procedure PlotGraph;
  end;

var
  MainForm: TMainForm;

{------------------------------------------------------------------------}
implementation
Uses
   lcard_ad;

Var   Rate : Word; Chan:Integer;

{$R *.DFM}

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
   PlotGraph;
end;

Const
   NPoint = 100;
procedure TMainForm.PlotGraph;
type
   TData = array [1..32767] of Integer;
Var
   pData          : ^TData;
   X0, Y0, X1, Y1 : Integer;
   j              : Integer;
   Max            : Real;
begin
   GetVariables;
   getmem(pData, NPoint * 2);

   with PaintBox1 do
   begin
      X0:=0;
      X1:=BoundsRect.Right-BoundsRect.Left;
      Y0:=0;
      Y1:=BoundsRect.Bottom-BoundsRect.Top;

      {      }
      if ModeCB.State=cbChecked then
         begin
            {    DMA }
            DMAONE(pData^, NPoint, CREATE_CHANNEL(Chan,0,0), Rate, 0);
            while DMA_TEST=0 do ;
            DMA_OFF;
         end
      else
         STREAM(pData^, NPoint, CREATE_CHANNEL(Chan,0,0), Rate);

      Canvas.Brush.Color:=clNavy;
      Canvas.Rectangle(0,0,X1,Y1);

      Canvas.Pen.Color:=clYellow;
      Canvas.MoveTo(0,Y1 div 2);
      Canvas.LineTo(X1,Y1 div 2);

      Max:=1;
      for j:=1 to NPoint do
         if Abs(pData^[j])>Max then
             Max:=Abs(pData^[j]);
      Max:=Max*1.2;

      Canvas.MoveTo(round(1/NPoint*X1), -round(pData^[1]/Max*Y1/2)+Y1 div 2);
      for j:=2 to NPoint-1 do
         Canvas.LineTo(round(j/NPoint*X1), -round(pData^[j]/Max*Y1/2)+Y1 div 2);
   end;
   freemem(pData, NPoint*2);
end;


procedure TMainForm.ADChanSBDownClick(Sender: TObject);
Var Err:Integer;
begin
   GetVariables;
   Dec(Chan);
   if Chan<0 then Chan:=0;
   PutVariables;
   PlotGraph;
end;

procedure TMainForm.ADChanSBUpClick(Sender: TObject);
Var Err:Integer;
begin
   GetVariables;
   Inc(Chan);
   PutVariables;
   PlotGraph;
end;

procedure TMainForm.PeriodSBDownClick(Sender: TObject);
Var Err:Integer;
begin
   GetVariables;
   Rate:=Rate - 10;
   if Rate<10 then Rate:=10;
   PutVariables;
   PlotGraph;
end;

procedure TMainForm.PeriodSBUpClick(Sender: TObject);
Var Err:Integer;
begin
   GetVariables;
   Rate:=Rate + 10;
   PutVariables;
   PlotGraph;
end;

procedure TMainForm.PutVariables;
begin
   AdChanEd.Text:=IntToStr(Chan);
   RateEd.Text:=IntToStr(Rate);
end;

procedure TMainForm.GetVariables;
Var
   Err:Boolean;
begin
   Err:=False;
   try
      Chan:=StrToInt(AdChanEd.Text);
      Rate:=StrToInt(RateEd.Text);
      if Chan<0 then Chan:=0;
      if Chan>31 then Chan:=31;
      if Rate<10 then Rate:=10;
   except
      on EConvertError do Err:=True;
      on ERangeError do Err:=True;
   end;
   ErrorLab.Visible:=Err;
end;



procedure TMainForm.CancelBtnClick(Sender: TObject);
begin
   Close;
end;

end.
